_G.CharacterManipulator = _G.CharacterManipulator or {}

CharacterManipulator.ModPath = ModPath
CharacterManipulator.SavePath = SavePath .. "CharacterManipulator.txt"
CharacterManipulator.Options = CharacterManipulator.Options or {}

CharacterManipulator.Menu = "CharacterManipulatorMenu"

CharacterManipulator.HookFiles = {
	[ "lib/tweak_data/blackmarkettweakdata" ] = "lib/blackmarkettweakdata.lua"
}

function CharacterManipulator:Save()

	local data = io.open( self.SavePath , "w+" )
	
	if data then
		data:write( json.encode( self.Options ) )
		data:close()
	end
	
end

function CharacterManipulator:Load()

	local data = io.open( self.SavePath , "r" )
	
	if data then
		self.Options = json.decode( data:read( "*all" ) )
		data:close()
	end
	
end

function CharacterManipulator:CharacterIndex( workname )

	for i , c in ipairs( tweak_data.criminals.characters ) do
		if c.name == workname then return i end
	end
	return nil

end

Hooks:Add( "MenuManagerSetupCustomMenus" , "CharacterManipulatorPostMenuManagerSetupCustomMenus" , function( self , nodes )
    
	MenuHelper:NewMenu( CharacterManipulator.Menu )
	
end )

Hooks:Add( "LocalizationManagerPostInit" , "CharacterManipulatorPostLocalizationManagerInit" , function( self )

	self:add_localized_strings({
		[ "CharacterManipulatorT" ] = "Character Manipulator",
		[ "CharacterManipulatorD" ] = "Uh, not you Hox - I mean Old... Look, we'll sort out names later."
	})
	
	for i , c in ipairs( tweak_data.criminals.characters ) do
	
		self:add_localized_strings({
			[ "CM_" .. c.name ] = "Change the current appearance of " .. self:text( "menu_" .. c.name ) .. "."
		})
		
		CharacterManipulator.Characters = CharacterManipulator.Characters or {}
		table.insert( CharacterManipulator.Characters , "menu_" .. c.name )
		
	end
	
	CharacterManipulator:Load()

end )

Hooks:Add( "MenuManagerBuildCustomMenus" , "CharacterManipulatorPostMenuManagerBuildCustomMenus" , function( self , nodes )

    nodes[ CharacterManipulator.Menu ] = MenuHelper:BuildMenu( CharacterManipulator.Menu )
    MenuHelper:AddMenuItem( MenuHelper.menus.lua_mod_options_menu , CharacterManipulator.Menu , "CharacterManipulatorT" , "CharacterManipulatorD" )
	
end )

Hooks:Add( "MenuManagerPopulateCustomMenus" , "CharacterManipulatorPostMenuManagerPopulateCustomMenus" , function( self , nodes )

	for i , c in ipairs( tweak_data.criminals.characters ) do
		
		MenuCallbackHandler[ c.name .. "_character" ] = function( self , item )
			CharacterManipulator.Options[ c.name ] = tweak_data.criminals.characters[ item:value() ].name
			CharacterManipulator:Save()
		end
		
		MenuHelper:AddMultipleChoice({
			id 			= "CM_" .. c.name .. "_character",
			title 		= "menu_" .. c.name,
			desc 		= "CM_" .. c.name,
			callback 	= c.name .. "_character",
			items 		= CharacterManipulator.Characters,
			menu_id 	= CharacterManipulator.Menu,
			value 		= CharacterManipulator:CharacterIndex( CharacterManipulator.Options[ c.name ] ) or i
		})
	
	end

end )

if RequiredScript then

	local requiredScript = RequiredScript:lower()
	
	if CharacterManipulator.HookFiles[ requiredScript ] then
		dofile( CharacterManipulator.ModPath .. CharacterManipulator.HookFiles[ requiredScript ] )
	end
	
end