local function OldToNew( w )

	local t = {
		american = "hoxton",
		german = "wolf",
		russian = "dallas",
		spanish = "chains"
	}
	return t[ w ] or w

end

local function NewToOld( w )
	
	local t = {
		hoxton = "american",
		wolf = "german",
		dallas = "russian",
		chains = "spanish"
	}
	return t[ w ] or w
	
end

Hooks:PostHook( BlackMarketTweakData , "_init_characters" , "CharacterManipulatorPostBlackMarketTweakDataInitCharacters" , function( self )
	
	CharacterManipulator:Load()
	
	local orig = self.characters
	
	for a , b in pairs( orig.locked ) do
		
		local o = NewToOld( a )
		
		if CharacterManipulator and CharacterManipulator.Options and CharacterManipulator.Options[ o ] then
		
			local n = OldToNew( CharacterManipulator.Options[ o ] )
			
			if orig[ n ] then
			
				self.characters.locked[ a ].sequence = orig[ n ].sequence
				
				if orig[ n ].mask_on_sequence then
					self.characters.locked[ a ].mask_on_sequence = orig[ n ].mask_on_sequence
				end
				if orig[ n ].mask_off_sequence then
					self.characters.locked[ a ].mask_off_sequence = orig[ n ].mask_off_sequence
				end
				
			elseif orig.locked[ n ] then
			
				self.characters.locked[ a ].sequence = orig.locked[ n ].sequence
				
				if orig.locked[ n ].mask_on_sequence then
					self.characters.locked[ a ].mask_on_sequence = orig.locked[ n ].mask_on_sequence
				end
				if orig.locked[ n ].mask_off_sequence then
					self.characters.locked[ a ].mask_off_sequence = orig.locked[ n ].mask_off_sequence
				end
				
			end
			
			log( "Character Manipulator: Successfully converted id \"" .. o .. "\" to id \"" .. n .. "\"!" )
			
		end
	
	end
	
	for a , b in pairs( orig ) do
	
		local o = NewToOld( a )
		
		if CharacterManipulator and CharacterManipulator.Options and CharacterManipulator.Options[ o ] then
		
			local n = OldToNew( CharacterManipulator.Options[ o ] )
			
			if orig[ n ] then
			
				self.characters[ a ].fps_unit = orig[ n ].fps_unit
				self.characters[ a ].npc_unit = orig[ n ].npc_unit
				self.characters[ a ].menu_unit = orig[ n ].menu_unit
				
				self.characters[ a ].sequence = orig[ n ].sequence
				
				if orig[ n ].mask_on_sequence then
					self.characters[ a ].mask_on_sequence = orig[ n ].mask_on_sequence
				end
				
				if orig[ n ].mask_off_sequence then
					self.characters[ a ].mask_off_sequence = orig[ n ].mask_off_sequence
				end
				
			elseif orig.locked[ n ] then
			
				self.characters[ a ].fps_unit = orig.locked.fps_unit
				self.characters[ a ].npc_unit = orig.locked.npc_unit
				self.characters[ a ].menu_unit = orig.locked.menu_unit
				
				self.characters[ a ].sequence = orig.locked[ n ].sequence
				
				if orig.locked[ n ].mask_on_sequence then
					self.characters[ a ].mask_on_sequence = orig.locked[ n ].mask_on_sequence
				end
				
				if orig.locked[ n ].mask_off_sequence then
					self.characters[ a ].mask_off_sequence = orig.locked[ n ].mask_off_sequence
				end
				
			end
			
			if orig[ "ai_" .. a ] then
			
				local i = "ai_" .. a
				local m = "ai_" .. n
				
				self.characters[ i ].npc_unit = orig[ m ].npc_unit
				self.characters[ i ].sequence = orig[ m ].sequence
				
				if orig[ m ].mask_on_sequence then
					self.characters[ i ].mask_on_sequence = orig[ m ].mask_on_sequence
				end
				
				if orig[ m ].mask_off_sequence then
					self.characters[ i ].mask_off_sequence = orig[ m ].mask_off_sequence
				end
				
			end
			
			log( "Character Manipulator: Successfully converted id \"" .. o .. "\" to id \"" .. n .. "\"!" )
		
		end
		
	end

end )